//+------------------------------------------------------------------+
//|                                                      ZZ_line.mq4 |
//|                               http://www.mql4.com/ru/users/IgorM |
//|                               http://www.mql4.com/ru/users/IgorM |
//+------------------------------------------------------------------+
#property copyright "http://www.mql4.com/ru/users/IgorM"
#property link      "http://www.mql4.com/ru/users/IgorM"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Blue

extern int ExtDepth=12;
extern int ExtDeviation=5;
extern int ExtBackstep=3;

int lasti;
double lasttmp;
//--- buffers
double buf[];

int init(){
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,buf);
//   ArrayInitialize(buf,0);
   lasti = Bars-1;
   lasttmp = Close[lasti];
return(0);
}
int deinit(){
return(0);
}
int start(){
   int    i,j,counted_bars;
   double tmp,Py;
   counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   i=MathMax(Bars-counted_bars,lasti);
   while(i>1){
      i = zzsearch(tmp,ExtDepth,ExtDeviation,ExtBackstep,0,i);
      j=lasti;
      if(i>0){
         Py = (lasttmp-tmp)/((lasti-i)+DBL_MIN);
         buf[j] = lasttmp;
         j--;
         while(j>i){
            buf[j] = buf[j+1]-Py;
            j--;
         }
         lasti= i;
         lasttmp = tmp;
      }else{
         if(lasttmp>Close[0]) Py = (lasttmp-Low[0])/lasti; else Py = (lasttmp-High[0])/lasti;
         buf[j] = lasttmp;
         j--;
         while(j>=0){
            buf[j] = buf[j+1]-Py;
            j--;
         }
      }
      i--;
   }
return(0);
}
//__________________________________________________________________________
int zzsearch(double &zzret,int param1,int param2,int param3,int zzbuf,int last=-1){
   int i;
   double zz;
   zz =0;
   i  = last;
   while((zz == 0 || zz == EMPTY_VALUE || zz == EMPTY) && i>0){
         zz = iCustom(NULL,0,"ZigZag",param1,param2,param3,zzbuf,i);
         i--;
   }
         if(i<=0) i = -1; else i++;
   zzret = zz;
return(i);
}

